'/* BTRIEVE.H  25.07.2002 */

const BTRV.ERR = 20                             '/* Btrieve-not-loaded error */
const BTRV.IV2 = &hab00                 '/* code for interrupt 2F to Btrieve */
const BTRV.IVM = &h2f                        '/* multi-user interrupt vector */
const BTRV.IVS = &h7b                          '/* standard interrupt vector */
const BTRV.OWS = &h33                         '/* offset-within-segment code */
const BTRV.VLN = &h6176                        '/* variable-length-record ID */

const BTRV.EXCL       =  -4                   '/* exclusive-access file mode */
const BTRV.RO         =  -2                          '/* read-only file mode */
const BTRV.FAST       =  -1                        '/* fast-access file mode */
const BTRV.NORMAL     =   0                      '/* normal-access file mode */
const BTRV.OPEN       =   0                          '/* open a Btrieve file */
const BTRV.CLOSE      =   1                         '/* close a Btrieve file */
const BTRV.DUP        =   1          '/* duplicate attribute for file-create */
const BTRV.INSERT     =   2                      '/* insert a Btrieve record */
const BTRV.MOD        =   2         '/* modifiable attribute for file-create */
const BTRV.UPDATE     =   3                      '/* update a Btrieve record */
const BTRV.BIN        =   4             '/* binary attribute for file-create */
const BTRV.DELETE     =   4                      '/* delete a Btrieve record */
const BTRV.NOTFND     =   4                  '/* record not found error code */
const BTRV.DUPLICATE  =   5                  '/* duplicate-record error code */
const BTRV.GETEQ      =   5     '/* get Btrieve record equal to supplied key */
const BTRV.GETNEXT    =   6                      '/* get next Btrieve record */
const BTRV.GETPREV    =   7                  '/* get previous Btrieve record */
const BTRV.GETGT      =   8      '/* get Btrieve record greater-than current */
const BTRV.NUL        =   8           '/* null-key attribute for file-create */
const BTRV.EOF        =   9                       '/* end-of-file error code */
const BTRV.GETGE      =   9     '/* get Btrieve record greater/equal current */
const BTRV.GETLT      =  10         '/* get Btrieve record less-than current */
const BTRV.GETLE      =  11   '/* get Btrieve record less-than/equal current */
const BTRV.GETLO      =  12           '/* get lowest Btrieve record in index */
const BTRV.NOFILE     =  12                    '/* file not found error code */
const BTRV.GETHI      =  13          '/* get highest Btrieve record in index */
const BTRV.CREATE     =  14                        '/* create a Btrieve file */
const BTRV.STAT       =  15                  '/* get statistics about a file */
const BTRV.SEG        =  16          '/* segmented attribute for file-create */
const BTRV.GETPOS     =  22     '/* get physical position for Btrieve record */
const BTRV.GETDIRECT  =  23    '/* get Btrieve record from physical position */
const BTRV.STEPNEXT   =  24             '/* get next physical record in file */
const BTRV.RESET      =  28                      '/* close all Btrieve files */
const BTRV.ALT        =  32          '/* collating attribute for file-create */
const BTRV.STEPFIRST  =  33            '/* get first physical record in file */
const BTRV.STEPLAST   =  34             '/* get last physical record in file */
const BTRV.STEPPREV   =  35         '/* get previous physical record in file */
const BTRV.GETEQKEY   =  55          '/* get key value equal to supplied key */
const BTRV.GETNEXTKEY =  56                           '/* get next key value */
const BTRV.GETPREVKEY =  57                       '/* get previous key value */
const BTRV.GETGTKEY   =  58           '/* get key value greater-than current */
const BTRV.GETGEKEY   =  59          '/* get key value greater/equal current */
const BTRV.GETLTKEY   =  60              '/* get key value less-than current */
const BTRV.GETLEKEY   =  61        '/* get key value less-than/equal current */
const BTRV.GETLOKEY   =  62                '/* get lowest key value in index */
const BTRV.GETHIKEY   =  63               '/* get highest key value in index */
const BTRV.DES        =  64         '/* descending attribute for file-create */
const BTRV.CONFLICT   =  80            '/* delete/update conflict error code */
const BTRV.SUP        = 128       '/* supplemental attribute for file-create */
const BTRV.EXT        = 256           '/* extended attribute for file-create */
'const BTRV.ALT        =  32         '/* collating attribute for file-create */
'const BTRV.BIN        =   4            '/* binary attribute for file-create */
'const BTRV.CLOSE      =   1                        '/* close a Btrieve file */
'const BTRV.CONFLICT   =  80           '/* delete/update conflict error code */
'const BTRV.CREATE     =  14                       '/* create a Btrieve file */
'const BTRV.DELETE     =   4                     '/* delete a Btrieve record */
'const BTRV.DES        =  64        '/* descending attribute for file-create */
'const BTRV.DUP        =   1         '/* duplicate attribute for file-create */
'const BTRV.DUPLICATE  =   5                 '/* duplicate-record error code */
'const BTRV.EOF        =   9                      '/* end-of-file error code */
'const BTRV.EXCL       =  -4                  '/* exclusive-access file mode */
'const BTRV.EXT        = 256          '/* extended attribute for file-create */
'const BTRV.FAST       =  -1                       '/* fast-access file mode */
'const BTRV.GETDIRECT  =  23   '/* get Btrieve record from physical position */
'const BTRV.GETEQ      =   5    '/* get Btrieve record equal to supplied key */
'const BTRV.GETEQKEY   =  55         '/* get key value equal to supplied key */
'const BTRV.GETGE      =   9    '/* get Btrieve record greater/equal current */
'const BTRV.GETGEKEY   =  59         '/* get key value greater/equal current */
'const BTRV.GETGT      =   8     '/* get Btrieve record greater-than current */
'const BTRV.GETGTKEY   =  58          '/* get key value greater-than current */
'const BTRV.GETHI      =  13         '/* get highest Btrieve record in index */
'const BTRV.GETHIKEY   =  63              '/* get highest key value in index */
'const BTRV.GETLE      =  11  '/* get Btrieve record less-than/equal current */
'const BTRV.GETLEKEY   =  61       '/* get key value less-than/equal current */
'const BTRV.GETLO      =  12          '/* get lowest Btrieve record in index */
'const BTRV.GETLOKEY   =  62               '/* get lowest key value in index */
'const BTRV.GETLT      =  10        '/* get Btrieve record less-than current */
'const BTRV.GETLTKEY   =  60             '/* get key value less-than current */
'const BTRV.GETNEXT    =   6                     '/* get next Btrieve record */
'const BTRV.GETNEXTKEY =  56                          '/* get next key value */
'const BTRV.GETPOS     =  22    '/* get physical position for Btrieve record */
'const BTRV.GETPREV    =   7                 '/* get previous Btrieve record */
'const BTRV.GETPREVKEY =  57                      '/* get previous key value */
'const BTRV.INSERT     =   2                     '/* insert a Btrieve record */
'const BTRV.MOD        =   2        '/* modifiable attribute for file-create */
'const BTRV.NOFILE     =  12                   '/* file not found error code */
'const BTRV.NORMAL     =   0                     '/* normal-access file mode */
'const BTRV.NOTFND     =   4                 '/* record not found error code */
'const BTRV.NUL        =   8          '/* null-key attribute for file-create */
'const BTRV.OPEN       =   0                         '/* open a Btrieve file */
'const BTRV.RESET      =  28                     '/* close all Btrieve files */
'const BTRV.RO         =  -2                         '/* read-only file mode */
'const BTRV.SEG        =  16         '/* segmented attribute for file-create */
'const BTRV.STAT       =  15                 '/* get statistics about a file */
'const BTRV.STEPFIRST  =  33           '/* get first physical record in file */
'const BTRV.STEPLAST   =  34            '/* get last physical record in file */
'const BTRV.STEPNEXT   =  24            '/* get next physical record in file */
'const BTRV.STEPPREV   =  35        '/* get previous physical record in file */
'const BTRV.SUP        = 128      '/* supplemental attribute for file-create */
'const BTRV.UPDATE     =   3                     '/* update a Btrieve record */

const DTYP.AUTOINC    = 15       '/* DDF auto-increment (long int) data type */
const DTYP.BFLOAT     =  9             '/* DDF Microsoft MBF float data type */
const DTYP.BOOLEAN    =  7              '/* DDF boolean data type (0 to ???) */
const DTYP.BTRVDATE   =  3             '/* DDF Btrieve date (dmyy) data type */
const DTYP.BTRVTIME   =  4             '/* DDF Btrieve time (ssmh) data type */
const DTYP.FLOAT      =  2            '/* DDF Microsoft IEEE float data type */
const DTYP.INTEGER    =  1         '/* DDF Microsoft/Intel integer data type */
const DTYP.NOTE1      = 12            '/* DDF variable-length text data type */
const DTYP.NOTE2      = 13            '/* DDF variable-length text data type */
const DTYP.STRING     =  0          '/* DDF Microsoft BASIC string data type */

const PTYP.AUTOINC    = 20       '/* PDD auto-increment (long int) data type */
const PTYP.BOOLEAN    = 21         '/* PDD boolean/byte data type (0 to 255) */
const PTYP.BTRVDATE   =  9             '/* PDD Btrieve date (dmyy) data type */
const PTYP.BTRVTIME   = 11             '/* PDD Btrieve time (ssmh) data type */
const PTYP.DOUBLEIEEE =  6     '/* PDD Microsoft IEEE double-float data type */
const PTYP.DOUBLEMBF  =  4      '/* PDD Microsoft MBF double-float data type */
const PTYP.LONGINT    =  2    '/* PDD Microsoft/Intel long integer data type */
const PTYP.PLATDATE   =  7          '/* PDD Platinum date (mmddyy) data type */
const PTYP.SHORTINT   =  1   '/* PDD Microsoft/Intel short integer data type */
const PTYP.SINGLEIEEE =  5     '/* PDD Microsoft IEEE single-float data type */
const PTYP.SINGLEMBF  =  3      '/* PDD Microsoft MBF single-float data type */
const PTYP.STRING     =  0          '/* PDD Microsoft BASIC string data type */

type SREGS               '/* DOS extended segment registers for int86x calls */
   ax as integer
   bx as integer
   cx as integer
   dx as integer
   bp as integer
   si as integer
   di as integer
   flags as integer
   ds as integer
   es as integer
end type

declare function BTRV(ioper, cfcb, cbuf, ilen, ckey, ikey)
declare function io.btrv(ioper, cfcb, cbuf, ilen, ckey, ikey)

common shared ibtrvds()                           '/* Btrieve data structure */
common shared ibtrvas                      '/* current array-segment address */
common shared ibtrvid                                 '/* Btrieve process ID */
common shared ibtrvmu                '/* TRUE when multi-user Btrieve loaded */
common shared ibtrvns                    '/* current numeric-segment address */
common shared ibtrvss                     '/* current string-segment address */
common shared ibtrvvs             '/* TRUE when Btrieve version has been set */
common shared srg as SREGS                         '/* DOS segment registers */
