'/* UNPKTEXT.BAS  Unpack a text database built by TXTPROC2.BAS */
'/*               By: Dale Thorn                               */
'/*               Rev. 16.04.2000                              */

'$include: 'basdef.h'
'$include: 'filekill.h'
'$include: 'fileopen.h'
'$include: 'longname.h'
'$include: 'messages.h'
'$include: 'midchar.h'
'$include: 'parmstr1.h'
'$include: 'string.h'
'$include: 'basdef.bas'
'$include: 'filekill.bas'
'$include: 'fileopen.bas'
'$include: 'longname.bas'
'$include: 'messages.bas'
'$include: 'midchar.bas'
'$include: 'parmstr1.bas'
'$include: 'string.bas'

ccmd = ucase$(rtrim$(command$))         'get the user's command-line parameters
if ccmd = "" then                              'a command line was NOT supplied
   i = ifn.msgs("Usage:  UNPKTEXT  filename", 5, 24, 79, 0, 1) 'disp.msg.& exit
end if                              'display the usage message [above] and exit

iprm = parmstr1(ccmd, cfil, cnam, cext, cprm())  'parse command-line parameters
if cnam = "" or len(cnam) > 8 or len(cext) > 3 or instr(cext, ".") _
or iprm >= 0 then                    'invalid filename or additional parameters
   i = ifn.msgs("Invalid filename", 5, 24, 79, 1, 1)             'beep and exit
end if                              'display the error message [above] and exit

i = ifn.open(1, cfil, "S", llof)             'open the source file in text mode
if llof < 0 then                                'user input a wildcard filespec
   i = ifn.msgs("Invalid filename", 5, 24, 79, 1, 1)             'beep and exit
elseif llof = 0 then                          'source file nonexistent or empty
   i = ifn.kill(1, cfil)                             'kill the zero-length file
   i = ifn.msgs(cfil + " not found", 5, 24, 79, 1, 1)            'beep and exit
end if                              'display the error message [above] and exit

i = ifn.msgs("Please standby", 5, 24, 79, 0, 0)    'display message and proceed

ctst1 = string$(3, 254)             'original filenames wrappers in source file
ctst2 = string$(79, 254)         'original files separator lines in source file

init = 0                                'initialize the first-line-of-file flag
while not eof(1)                        'loop thru all lines in the source file
   line input #1, clin                  'read 1st or next line from source file
   if clin = ctst2 then               '1st of 3 sep.lines marking original file
      line input #1, clin              'read 2nd sep.line marking original file
      line input #1, clin              'read 3rd sep.line marking original file
      close #2                        'close the possibly open destination file
   elseif left$(clin, 3) = ctst1 and right$(clin, 3) = ctst1 then'filename line
      init = not init                   'toggle the first or last filename line
      if init then                             'this is the first filename line
         cdst = mid$(clin, 4, len(clin) - 6)   'get filename from filename line
         open cdst for output as #2             'open new copy of original file
      end if
   else                                          'just an ordinary text line...
      print #2, clin                            'print text line to output file
   end if
wend

i = ifn.msgs("Process completed for: " + cfil, 5, 24, 79, 0, 1)'disp.msg.& exit
close                                 'close all files in case not closed above
system                                              'return to operating system
